<template>
  <va-card>
    <!--
    <va-input
      v-model="timer"
      @keyup.enter="toggle"
      class="mb-4"
      rounded
      :rules="[(value) => value > 0 || `Value has to be greater than 0`]"
      :format="formatFn"
    />
     -->
    <!-- Waiting for merging https://github.com/epicmaxco/vuestic-ui/pull/1213. Actually input is overlayed by the modal. -->
    <va-time-input
      v-model="timer"
      label="Timer"
      :messages="messages"
      :return-raw="true"
      view="seconds"
    />
    <p v-if="debug">{{ timer }}</p>
  </va-card>
</template>

<script lang="ts">
import { Vue } from "vue-class-component";
import { useStore } from "vuex";
import { key } from "@/store";

export default class TickTack extends Vue {
  // formatFn: (d: Date) => string = (d: Date) => d.toLocaleTimeString();
  messages = ["Press enter to start timer"];
  store = useStore(key);
  get timer(): Date {
    const t = this.store.getters.timer;
    console.log("Grabbed:", t);
    return new Date(t);
  }
  set timer(value: Date) {
    //const sec = value.getSeconds();
    const offset = value.getTimezoneOffset() * 60000;
    const tim = value.getTime() - offset;
    console.log("Value: %o and Sec: %d and Offset: %d", value, tim, offset);
    if (tim / 1000 > 0) {
      this.store.commit("setTimer", tim);
    }
  }
  get debug(): boolean {
    return process.env.NODE_ENV !== "production";
  }
  toggle(): void {
    this.store.dispatch("toggle");
  }
}
</script>
